diff -crB mplp_ver2/cycle.h mplp_ver2.src-patched/cycle.h
*** mplp_ver2/cycle.h	2014-10-19 21:32:10.000000000 +0200
--- mplp_ver2.src-patched/cycle.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 664,685 ****
  
  // Create the expanded projection graph by including all singleton partitions and also
  // all partitions found by calling FindPartition on all edges.
! int create_expanded_projection_graph(MPLPAlg& mplp, vector<int>& projection_imap_var, vector<vector<pair<int, double> > >& projection_adjacency_list, map<pair<int, int>, double>&projection_edge_weights, double* &array_of_sij, int& array_of_sij_size, vector<vector<int> >& partition_imap) {
    // projection_imap_var maps from projection node to variable
    // partition_imap maps from projection node to vector of states
  
    int num_of_vars = mplp.m_var_sizes.size();
!   vector<map<vector<int>,int> > partition_set;
!   set<double> set_of_sij;
    int num_projection_nodes = 0;
  
    for (int i = 0; i < num_of_vars; i++) {
!     map<vector<int>,int> p;
      partition_set.push_back(p);
  
      // push all singleton partitions
      for (int i_state = 0; i_state < mplp.m_var_sizes[i]; i_state++) {
!       vector<int> single;
        single.push_back(i_state);
        partition_set[i][single] = 1;
      }
--- 663,684 ----
  
  // Create the expanded projection graph by including all singleton partitions and also
  // all partitions found by calling FindPartition on all edges.
! int create_expanded_projection_graph(MPLPAlg& mplp, std::vector<int>& projection_imap_var, std::vector<std::vector<std::pair<int, double> > >& projection_adjacency_list, std::map<std::pair<int, int>, double>&projection_edge_weights, double* &array_of_sij, int& array_of_sij_size, std::vector<std::vector<int> >& partition_imap) {
    // projection_imap_var maps from projection node to variable
    // partition_imap maps from projection node to vector of states
  
    int num_of_vars = mplp.m_var_sizes.size();
!   std::vector<std::map<std::vector<int>,int> > partition_set;
!   std::set<double> set_of_sij;
    int num_projection_nodes = 0;
  
    for (int i = 0; i < num_of_vars; i++) {
!      std::map<std::vector<int>,int> p;
      partition_set.push_back(p);
  
      // push all singleton partitions
      for (int i_state = 0; i_state < mplp.m_var_sizes[i]; i_state++) {
!        std::vector<int> single;
        single.push_back(i_state);
        partition_set[i][single] = 1;
      }
***************
*** 710,729 ****
      }
      clock_t find_partition_end_time = clock();
      double find_partition_total_time = (double)(find_partition_end_time - find_partition_start_time)/CLOCKS_PER_SEC;
!     if (DEBUG_MODE) {
        printf(" -- find_partition. Took %lg seconds\n", find_partition_total_time);
      }
    }
  
    // Create one projection node for each remaining partition. Overload value of partition_set
    // to now refer to the node number in the projection graph.
!   for(int i=0; i < partition_set.size(); i++) {
!     for(map<vector<int>, int>::iterator it = partition_set[i].begin(); it != partition_set[i].end(); it++) {
        it->second = num_projection_nodes++;
        projection_imap_var.push_back(i);
        partition_imap.push_back(it->first);
  
!       vector<pair<int, double> > temp;
        projection_adjacency_list.push_back(temp);
      }
    }
--- 709,728 ----
      }
      clock_t find_partition_end_time = clock();
      double find_partition_total_time = (double)(find_partition_end_time - find_partition_start_time)/CLOCKS_PER_SEC;
!     if (MPLP_DEBUG_MODE) {
        printf(" -- find_partition. Took %lg seconds\n", find_partition_total_time);
      }
    }
  
    // Create one projection node for each remaining partition. Overload value of partition_set
    // to now refer to the node number in the projection graph.
!   for(size_t i=0; i < partition_set.size(); i++) {
!     for(std::map<std::vector<int>, int>::iterator it = partition_set[i].begin(); it != partition_set[i].end(); it++) {
        it->second = num_projection_nodes++;
        projection_imap_var.push_back(i);
        partition_imap.push_back(it->first);
  
!       std::vector<std::pair<int, double> > temp;
        projection_adjacency_list.push_back(temp);
      }
    }
***************
*** 746,753 ****
  
      if (mplp.m_var_sizes[i] <= 1 || mplp.m_var_sizes[j] <= 1) continue;
      
!     vector<vector<double> > max_i_bij_not_xi;
!     vector<vector<double> > max_j_bij_not_xj;
  				
      for(int state1=0; state1 < mplp.m_var_sizes[i]; state1++) {
  					
--- 745,752 ----
  
      if (mplp.m_var_sizes[i] <= 1 || mplp.m_var_sizes[j] <= 1) continue;
      
!     std::vector<std::vector<double> > max_i_bij_not_xi;
!     std::vector<std::vector<double> > max_j_bij_not_xj;
  				
      for(int state1=0; state1 < mplp.m_var_sizes[i]; state1++) {
  					
***************
*** 756,762 ****
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
  						
!         vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  	  
          if(tmp_val > largest_val) {
--- 755,761 ----
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
  						
!          std::vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  	  
          if(tmp_val > largest_val) {
***************
*** 769,775 ****
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
          
!         vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
--- 768,774 ----
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
          
!          std::vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
***************
*** 779,786 ****
        
        // Assign values
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
! 	vector<double> state_j; max_j_bij_not_xj.push_back(state_j);
! 	max_j_bij_not_xj[state1].push_back(largest_val);
        }
        max_j_bij_not_xj[state1][largest_ind] = sec_largest_val;
      }
--- 778,785 ----
        
        // Assign values
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
!          std::vector<double> state_j; max_j_bij_not_xj.push_back(state_j);
!          max_j_bij_not_xj[state1].push_back(largest_val);
        }
        max_j_bij_not_xj[state1][largest_ind] = sec_largest_val;
      }
***************
*** 793,799 ****
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
  	
!         vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > largest_val) {
--- 792,798 ----
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
  	
!         std::vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > largest_val) {
***************
*** 806,812 ****
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
  	
!         vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
          
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
--- 805,811 ----
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
  	
!         std::vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
          
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
***************
*** 816,823 ****
  	
        // Assign values
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
! 	vector<double> state_i; max_i_bij_not_xi.push_back(state_i);
! 	max_i_bij_not_xi[state2].push_back(largest_val);
        }
        max_i_bij_not_xi[largest_ind][state1] = sec_largest_val;
      }
--- 815,822 ----
  	
        // Assign values
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
!          std::vector<double> state_i; max_i_bij_not_xi.push_back(state_i);
!          max_i_bij_not_xi[state2].push_back(largest_val);
        }
        max_i_bij_not_xi[largest_ind][state1] = sec_largest_val;
      }
***************
*** 858,875 ****
      // Now, for each partition of node i and each partition of node j, compute edge weights
      // If the edge weight is non-zero, insert edge into adjacency list
  
!     for(map<vector<int>, int>::iterator it_i = partition_set[i].begin(); it_i != partition_set[i].end(); it_i++) {
        int n = it_i->second;
  
!       for(map<vector<int>, int>::iterator it_j = partition_set[j].begin(); it_j != partition_set[j].end(); it_j++) {
! 	int m = it_j->second;
  
! 	double smn = 0;
          if (it_i->first.size() == 1 && it_j->first.size() == 1) {
            int xi = it_i->first[0]; int xj = it_j->first[0];
!           vector<int> inds; inds.push_back(xi); inds.push_back(xj);
            double tmp_val = edge_belief->GetVal(inds);
!           smn = max(tmp_val, max_ij_bij_not_xi_xj[xi][xj]) - max(max_i_bij_not_xi[xi][xj], max_j_bij_not_xj[xi][xj]);
          }
  	else if (it_i->first.size() == 1) {
            int xi = it_i->first[0];
--- 857,874 ----
      // Now, for each partition of node i and each partition of node j, compute edge weights
      // If the edge weight is non-zero, insert edge into adjacency list
  
!     for(std::map<std::vector<int>, int>::iterator it_i = partition_set[i].begin(); it_i != partition_set[i].end(); it_i++) {
        int n = it_i->second;
  
!       for(std::map<std::vector<int>, int>::iterator it_j = partition_set[j].begin(); it_j != partition_set[j].end(); it_j++) {
!         int m = it_j->second;
  
!         double smn = 0;
          if (it_i->first.size() == 1 && it_j->first.size() == 1) {
            int xi = it_i->first[0]; int xj = it_j->first[0];
!           std::vector<int> inds; inds.push_back(xi); inds.push_back(xj);
            double tmp_val = edge_belief->GetVal(inds);
!           smn = std::max(tmp_val, max_ij_bij_not_xi_xj[xi][xj]) - std::max(max_i_bij_not_xi[xi][xj], max_j_bij_not_xj[xi][xj]);
          }
  	else if (it_i->first.size() == 1) {
            int xi = it_i->first[0];
***************
*** 887,897 ****
  	if (smn != 0) {
  	  set_of_sij.insert(fabs(smn));
  
! 	  projection_adjacency_list[m].push_back(make_pair(n, smn));
! 	  projection_adjacency_list[n].push_back(make_pair(m, smn));
  
! 	  projection_edge_weights.insert(pair<pair<int, int>, double>(pair<int, int>(n, m), smn));
! 	  projection_edge_weights.insert(pair<pair<int, int>, double>(pair<int, int>(m, n), smn));
  	}
  
        }
--- 886,896 ----
  	if (smn != 0) {
  	  set_of_sij.insert(fabs(smn));
  
! 	  projection_adjacency_list[m].push_back(std::make_pair(n, smn));
! 	  projection_adjacency_list[n].push_back(std::make_pair(m, smn));
  
! 	  projection_edge_weights.insert(std::pair<std::pair<int, int>, double>(std::pair<int, int>(n, m), smn));
! 	  projection_edge_weights.insert(std::pair<std::pair<int, int>, double>(std::pair<int, int>(m, n), smn));
  	}
  
        }
***************
*** 899,912 ****
    }
    clock_t find_smn_end_time = clock();
    double find_smn_total_time = (double)(find_smn_end_time - find_smn_start_time)/CLOCKS_PER_SEC;
!   if (DEBUG_MODE) {
      printf(" -- find_smn. Took %lg seconds\n", find_smn_total_time);
    }
    
    array_of_sij = new double[set_of_sij.size()];
    array_of_sij_size = 0;
    
!   for (set<double>::iterator set_iter = set_of_sij.begin(); set_iter != set_of_sij.end(); set_iter++) {  //NOTE: PASSED AS FUNCTION ARG, DO NOT DELETE HERE!!
      array_of_sij[array_of_sij_size++] = *set_iter;
    }
  
--- 898,911 ----
    }
    clock_t find_smn_end_time = clock();
    double find_smn_total_time = (double)(find_smn_end_time - find_smn_start_time)/CLOCKS_PER_SEC;
!   if (MPLP_DEBUG_MODE) {
      printf(" -- find_smn. Took %lg seconds\n", find_smn_total_time);
    }
    
    array_of_sij = new double[set_of_sij.size()];
    array_of_sij_size = 0;
    
!   for (std::set<double>::iterator set_iter = set_of_sij.begin(); set_iter != set_of_sij.end(); set_iter++) {  //NOTE: PASSED AS FUNCTION ARG, DO NOT DELETE HERE!!
      array_of_sij[array_of_sij_size++] = *set_iter;
    }
  
***************
*** 915,921 ****
  
  
  // Creates the k-projection graph (just a single partition per variable)
! void create_k_projection_graph(MPLPAlg& mplp, vector<vector<int> > &projection_map, int& num_projection_nodes, vector<int> &projection_imap_var, vector<vector<int> > &partition_imap, map<pair<int, int>, double>& projection_edge_weights, adj_type &projection_adjacency_list, double* &array_of_sij, int& array_of_sij_size) {
  
    // TODO: make sure for binary variables that there is only one node per variable (rather than 2).
    // TODO: projection_edge_weights can likely be removed from this function and elsewhere.
--- 914,920 ----
  
  
  // Creates the k-projection graph (just a single partition per variable)
! void create_k_projection_graph(MPLPAlg& mplp, std::vector<std::vector<int> > &projection_map, int& num_projection_nodes, std::vector<int> &projection_imap_var, std::vector<std::vector<int> > &partition_imap, std::map<std::pair<int, int>, double>& projection_edge_weights, adj_type &projection_adjacency_list, double* &array_of_sij, int& array_of_sij_size) {
  
    // TODO: make sure for binary variables that there is only one node per variable (rather than 2).
    // TODO: projection_edge_weights can likely be removed from this function and elsewhere.
***************
*** 923,933 ****
  
    // Initialize the projection graph
    int projection_node_iter = 0;
!   for(int node=0; node < mplp.m_var_sizes.size(); node++) {
!     vector<int> i;
      
      for(int state=0; state < mplp.m_var_sizes[node]; state++) {
!       vector<pair<int, double> > temp;
        projection_adjacency_list.push_back(temp);
        i.push_back(projection_node_iter++);
      }
--- 922,932 ----
  
    // Initialize the projection graph
    int projection_node_iter = 0;
!   for(size_t node=0; node < mplp.m_var_sizes.size(); node++) {
!     std::vector<int> i;
      
      for(int state=0; state < mplp.m_var_sizes[node]; state++) {
!       std::vector<std::pair<int, double> > temp;
        projection_adjacency_list.push_back(temp);
        i.push_back(projection_node_iter++);
      }
***************
*** 937,947 ****
    num_projection_nodes = projection_node_iter;
  			
    projection_node_iter = 0;
!   for(int node=0; node < mplp.m_var_sizes.size(); node++) {
      for(int state=0; state < mplp.m_var_sizes[node]; state++) {
        projection_imap_var.push_back(node);
  
!       vector<int> tmp_state_vector;
        tmp_state_vector.push_back(state);
        partition_imap.push_back(tmp_state_vector);
  
--- 936,946 ----
    num_projection_nodes = projection_node_iter;
  			
    projection_node_iter = 0;
!   for(size_t node=0; node < mplp.m_var_sizes.size(); node++) {
      for(int state=0; state < mplp.m_var_sizes[node]; state++) {
        projection_imap_var.push_back(node);
  
!       std::vector<int> tmp_state_vector;
        tmp_state_vector.push_back(state);
        partition_imap.push_back(tmp_state_vector);
  
***************
*** 950,956 ****
    }
    
    // Iterate over all of the edges (we do this by looking at the edge intersection sets)
!   set<double> set_of_sij;
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it) {
        // Get the two nodes i & j and the edge intersection set. Put in right order.
      int i=it->first.first; int j=it->first.second;
--- 949,955 ----
    }
    
    // Iterate over all of the edges (we do this by looking at the edge intersection sets)
!   std::set<double> set_of_sij;
    for(mapType::const_iterator it = mplp.m_intersect_map.begin(); it != mplp.m_intersect_map.end(); ++it) {
        // Get the two nodes i & j and the edge intersection set. Put in right order.
      int i=it->first.first; int j=it->first.second;
***************
*** 978,984 ****
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
  						
!         vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  	  
          if(tmp_val > largest_val) {
--- 977,983 ----
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
  						
!         std::vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  	  
          if(tmp_val > largest_val) {
***************
*** 991,997 ****
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
          
!         vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
--- 990,996 ----
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[j]; state2++) {
          
!         std::vector<int> inds; inds.push_back(state1); inds.push_back(state2);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
***************
*** 1013,1019 ****
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
          
!         vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > largest_val) {
--- 1012,1018 ----
        int largest_ind = -1;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
          
!         std::vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
  						
          if(tmp_val > largest_val) {
***************
*** 1026,1032 ****
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
          
!         vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
          
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
--- 1025,1031 ----
        double sec_largest_val = -Inf;
        for(int state2=0; state2 < mplp.m_var_sizes[i]; state2++) {
          
!         std::vector<int> inds; inds.push_back(state2); inds.push_back(state1);
          double tmp_val = edge_belief->GetVal(inds);
          
          if(tmp_val > sec_largest_val && state2 != largest_ind) {
***************
*** 1079,1100 ****
        for(int xj=0; xj < mplp.m_var_sizes[j]; xj++) {
          int n = projection_map[j][xj];
          
!         vector<int> inds; inds.push_back(xi); inds.push_back(xj);
          double tmp_val = edge_belief->GetVal(inds);
          
          // Compute s_mn for this edge
!         double val_s = max(tmp_val, max_ij_bij_not_xi_xj[xi][xj]) - max(max_i_bij_not_xi[xi][xj], max_j_bij_not_xj[xi][xj]);
          
          // TODO: use threshold here, to make next stage faster
          if(val_s != 0) {          
!           projection_adjacency_list[m].push_back(make_pair(n, val_s));
!           projection_adjacency_list[n].push_back(make_pair(m, val_s));
            set_of_sij.insert(fabs(val_s));
          }
          
          // Insert into edge weight map
!         projection_edge_weights.insert(pair<pair<int,int>,double>(pair<int,int>(n, m), val_s));
!         projection_edge_weights.insert(pair<pair<int,int>,double>(pair<int,int>(m, n), val_s));
        }
      }
  
--- 1078,1099 ----
        for(int xj=0; xj < mplp.m_var_sizes[j]; xj++) {
          int n = projection_map[j][xj];
          
!         std::vector<int> inds; inds.push_back(xi); inds.push_back(xj);
          double tmp_val = edge_belief->GetVal(inds);
          
          // Compute s_mn for this edge
!         double val_s = std::max(tmp_val, max_ij_bij_not_xi_xj[xi][xj]) - std::max(max_i_bij_not_xi[xi][xj], max_j_bij_not_xj[xi][xj]);
          
          // TODO: use threshold here, to make next stage faster
          if(val_s != 0) {          
!           projection_adjacency_list[m].push_back(std::make_pair(n, val_s));
!           projection_adjacency_list[n].push_back(std::make_pair(m, val_s));
            set_of_sij.insert(fabs(val_s));
          }
          
          // Insert into edge weight map
!         projection_edge_weights.insert(std::pair<std::pair<int,int>,double>(std::pair<int,int>(n, m), val_s));
!         projection_edge_weights.insert(std::pair<std::pair<int,int>,double>(std::pair<int,int>(m, n), val_s));
        }
      }
  
***************
*** 1104,1110 ****
    array_of_sij = new double[set_of_sij.size()];
    array_of_sij_size = 0;
  	
!   for(set<double>::iterator set_iter = set_of_sij.begin(); set_iter != set_of_sij.end(); ++set_iter) {
      array_of_sij[array_of_sij_size++] = *set_iter;
    }
  }
--- 1103,1109 ----
    array_of_sij = new double[set_of_sij.size()];
    array_of_sij_size = 0;
  	
!   for(std::set<double>::iterator set_iter = set_of_sij.begin(); set_iter != set_of_sij.end(); ++set_iter) {
      array_of_sij[array_of_sij_size++] = *set_iter;
    }
  }
***************
*** 1141,1154 ****
      for(int i = 0; i < num_projection_nodes && !found_odd_signed_cycle; i++) {
        if(node_sign[i] == 0) {
          node_sign[i] = 1; // root node
!         queue<int> q;
          q.push(i);
          
          while (!q.empty() && !found_odd_signed_cycle) {
            int current = q.front();
            q.pop();
            
!           for (int j = 0; j < projection_adjacency_list[current].size(); j++) {
              double smn = projection_adjacency_list[current][j].second;
              // Ignore edges with weight less than R
              if (fabs(smn) < R)
--- 1140,1153 ----
      for(int i = 0; i < num_projection_nodes && !found_odd_signed_cycle; i++) {
        if(node_sign[i] == 0) {
          node_sign[i] = 1; // root node
!         std::queue<int> q;
          q.push(i);
          
          while (!q.empty() && !found_odd_signed_cycle) {
            int current = q.front();
            q.pop();
            
!           for (size_t j = 0; j < projection_adjacency_list[current].size(); j++) {
              double smn = projection_adjacency_list[current][j].second;
              // Ignore edges with weight less than R
              if (fabs(smn) < R)
***************
*** 1198,1204 ****
  // Given an undirected graph, finds an odd-signed cycle.
  // This works by breath-first search. Better might be to find minimal depth tree.
  // NOTE: this function depends on the random seed becase it creates a random spanning tree.
! void FindCycles(vector<list<int> > &cycle_set, double optimal_R, int ncycles_to_add, adj_type &projection_adjacency_list) {
  
    double R = optimal_R;
    int num_projection_nodes = projection_adjacency_list.size();
--- 1197,1203 ----
  // Given an undirected graph, finds an odd-signed cycle.
  // This works by breath-first search. Better might be to find minimal depth tree.
  // NOTE: this function depends on the random seed becase it creates a random spanning tree.
! void FindCycles(std::vector<std::list<int> > &cycle_set, double optimal_R, int ncycles_to_add, adj_type &projection_adjacency_list) {
  
    double R = optimal_R;
    int num_projection_nodes = projection_adjacency_list.size();
***************
*** 1214,1220 ****
  
    // construct the rooted spanning tree(s) -- randomly choose a root!
    int* random_projection_node = random_permutation(num_projection_nodes);
!   //  if(DEBUG_MODE) {
    //    cout << "First random node is: " << random_projection_node[0] << endl;
    //  }
    
--- 1213,1219 ----
  
    // construct the rooted spanning tree(s) -- randomly choose a root!
    int* random_projection_node = random_permutation(num_projection_nodes);
!   //  if(MPLP_DEBUG_MODE) {
    //    cout << "First random node is: " << random_projection_node[0] << endl;
    //  }
    
***************
*** 1225,1231 ****
        node_parent[i] = i;
        node_depth[i] = 0;
        
!       queue<int> q;
        q.push(i);
  
        while (!q.empty()) {
--- 1224,1230 ----
        node_parent[i] = i;
        node_depth[i] = 0;
        
!       std::queue<int> q;
        q.push(i);
  
        while (!q.empty()) {
***************
*** 1234,1240 ****
          
          // Randomize the adjacency list        
          int* random_nbrs = random_permutation(projection_adjacency_list[current].size());
!         for (int rj = 0; rj < projection_adjacency_list[current].size(); rj++) {
            int j = random_nbrs[rj];
            int next = projection_adjacency_list[current][j].first;
            if (node_sign[next] == 0) {
--- 1233,1239 ----
          
          // Randomize the adjacency list        
          int* random_nbrs = random_permutation(projection_adjacency_list[current].size());
!         for (size_t rj = 0; rj < projection_adjacency_list[current].size(); rj++) {
            int j = random_nbrs[rj];
            int next = projection_adjacency_list[current][j].first;
            if (node_sign[next] == 0) {
***************
*** 1259,1270 ****
  
    // construct edge set that contains edges that are not parts of the tree
    // TODO: This can be made faster! Can be performed in CONSTANT time.
!   vector<list<int> > edge_set;
!   map<pair<int, int>, int> edge_map;
    
    for (int i = 0; i < num_projection_nodes; i++) {
!     for (int j = 0; j < projection_adjacency_list[i].size(); j++) {
!       if (node_parent[i] == j || node_parent[j] == i) {							
          continue;
        }
        double smn = projection_adjacency_list[i][j].second;
--- 1258,1269 ----
  
    // construct edge set that contains edges that are not parts of the tree
    // TODO: This can be made faster! Can be performed in CONSTANT time.
!   std::vector<std::list<int> > edge_set;
!   std::map<std::pair<int, int>, int> edge_map;
    
    for (int i = 0; i < num_projection_nodes; i++) {
!     for (size_t j = 0; j < projection_adjacency_list[i].size(); j++) {
!       if (node_parent[i] == static_cast<int>(j) || node_parent[j] == i) {
          continue;
        }
        double smn = projection_adjacency_list[i][j].second;
***************
*** 1294,1306 ****
          }
          while (temp_di >= 0) {
            if (anc_i == anc_j) { //least common ancestor found
!             list<int> temp;
              temp.push_back(i);
              temp.push_back(jj);
              temp.push_back(depth_of_i - temp_di + depth_of_j - temp_dj);
!             map<pair<int, int>, int>::iterator m_it = edge_map.find(make_pair(i, jj));
              if (m_it == edge_map.end()) {
!               edge_map[pair<int, int>(i, jj)] = depth_of_i - temp_di + depth_of_j - temp_dj;
                edge_set.push_back(temp);		
              }								
              break;
--- 1293,1305 ----
          }
          while (temp_di >= 0) {
            if (anc_i == anc_j) { //least common ancestor found
!              std::list<int> temp;
              temp.push_back(i);
              temp.push_back(jj);
              temp.push_back(depth_of_i - temp_di + depth_of_j - temp_dj);
!             std::map<std::pair<int, int>, int>::iterator m_it = edge_map.find(std::make_pair(i, jj));
              if (m_it == edge_map.end()) {
!               edge_map[std::pair<int, int>(i, jj)] = depth_of_i - temp_di + depth_of_j - temp_dj;
                edge_set.push_back(temp);		
              }								
              break;
***************
*** 1318,1327 ****
    sort(edge_set.begin(), edge_set.end(), edge_sorting);	
  
    // Note: here we do not check for duplicate variables 
!   for (int i = 0; i < edge_set.size() && cycle_set.size() < ncycles_to_add; i++) {
  
      // Get next edge (and depth) from sorted list
!     list<int> temp = edge_set.back();
      edge_set.pop_back();
  
      // Find least common ancestor
--- 1317,1326 ----
    sort(edge_set.begin(), edge_set.end(), edge_sorting);	
  
    // Note: here we do not check for duplicate variables 
!   for (size_t i = 0; i < edge_set.size() && static_cast<int>(cycle_set.size()) < ncycles_to_add; i++) {
  
      // Get next edge (and depth) from sorted list
!      std::list<int> temp = edge_set.back();
      edge_set.pop_back();
  
      // Find least common ancestor
***************
*** 1349,1355 ****
      }
      ancestor = left_anc;
  
!     list<int> cycle;
  
      // backtrace the found cycle
      while (node_parent[left] != ancestor) {
--- 1348,1354 ----
      }
      ancestor = left_anc;
  
!     std::list<int> cycle;
  
      // backtrace the found cycle
      while (node_parent[left] != ancestor) {
***************
*** 1373,1385 ****
  
  // Check to see if there are any duplicate variables, and, if so, shortcut
  // NOTE: this is not currently being used.
! void shortcut(list<int> &cycle, vector<int> &projection_imap_var, map<pair<int, int>, double>& projection_edge_weights, int& num_projection_nodes) {
  
    bool exist_duplicates = true;
    int cycle_array[cycle.size()]; int tmp_ind = 0;
    int cycle_sign[cycle.size()];
  
!   for (list<int>::iterator it=cycle.begin(); it!=cycle.end(); ++it) {
      cycle_array[tmp_ind++] = *it;
    }
  
--- 1372,1384 ----
  
  // Check to see if there are any duplicate variables, and, if so, shortcut
  // NOTE: this is not currently being used.
! void shortcut(std::list<int> &cycle, std::vector<int> &projection_imap_var, std::map<std::pair<int, int>, double>& projection_edge_weights, int& num_projection_nodes) {
  
    bool exist_duplicates = true;
    int cycle_array[cycle.size()]; int tmp_ind = 0;
    int cycle_sign[cycle.size()];
  
!   for (std::list<int>::iterator it=cycle.begin(); it!=cycle.end(); ++it) {
      cycle_array[tmp_ind++] = *it;
    }
  
